using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.Collections;

namespace FiveChess
{


    public class Game : MarshalByRefObject, IGame
    {



        #region Events
        public event GameEventHandler GameStatusChanged;
        protected void OnStatusChanged(GameEventArgs e)
        {
            if (this.GameStatusChanged != null)
                this.GameStatusChanged(this, e);
        } 
        #endregion

        protected Player nextPlayer;//һѡ
        protected List<Player> players = new List<Player>();

        protected Player[,] checkerBoard = new Player[15, 15];//(ÿһ)
        protected Stack<Point> History = new Stack<Point>();
        #region Private Method
        //Ϸ
        /*
        * 㷨
        * ڸϷֻȷų 5 ӵһʣ
        * ֻҪԸո¹ǸΪģû 5 ͬɫӾͺˡ
        */
         private Status CheckGameResult(Point step, Player player)
        {
            int x, y;
            Player LastPlayer = player;
            int n;
            
            #region 
            n = 1;
            y = step.Y;
            for (x = step.X - 1; x >= 0; x--)
            {
                if (checkerBoard[x,y ] == LastPlayer) n++;
                else break;
            }
            for (x = step.X + 1; x < 15; x++)
            {
                if (checkerBoard[x,y ] == LastPlayer) n++;
                else break;
            }
            if (n >= 5)
            {
                return Status.End;
            }
            
            #endregion


            #region 
            n = 1;
            x = step.X;
            for (y = step.Y - 1; y >= 0; y--)
            {
                if (checkerBoard[x,y ] == LastPlayer) n++;
                else break;
            }
            for (y = step.Y + 1; y < 15; y++)
            {
                if (checkerBoard[x,y ] == LastPlayer) n++;
                else break;
            }
            if (n >= 5)
            {
                return Status.End;
            }
            
            #endregion


            #region б
            n = 1;
            for (x = step.X + 1, y = step.Y - 1; x < 15 && y >= 0; x++, y--)//бߵϰ
            {
                if (checkerBoard[x,y ] == LastPlayer) n++;
                else break;
            }
            for (x = step.X - 1, y = step.Y + 1; x >= 0 && y < 15; x--, y++)//бߵ°
            {
                if (checkerBoard[x,y ] == LastPlayer) n++;
                else break;
            }
            if (n >= 5)
            {
                return Status.End;
            }
            
            #endregion


            #region б
            n = 1;
            for (x = step.X - 1, y = step.Y - 1; x >= 0 && y >= 0; x--, y--)//бߵϰ
            {
                if (checkerBoard[x,y ] == LastPlayer) n++;
                else break;
            }
            for (x = step.X + 1, y = step.Y + 1; x < 15 && y < 15; x++, y++)//бߵ°
            {
                if (checkerBoard[x,y ] == LastPlayer) n++;
                else break;
            }
            if (n >= 5)
            {
                return Status.End;
            }
            
            #endregion
            return Status.Playing;
        }

        #endregion

        protected Hashtable sinkerlist = new Hashtable();
        protected Hashtable sinkerHandlerlist = new Hashtable();

        #region IGame Ա
        public bool Play(Point step,Player player)
        {
            if (player != nextPlayer) return false;

            Result res = new Result();
            //¼
            History.Push(step);
            if (checkerBoard[step.X, step.Y] != Player.None)
                return false;

            checkerBoard[step.X, step.Y] = player;
            //壬ƽ
            if (History.Count >= 225)
            {
                //Win(None);
                res.Player = Player.None;
                res.Status = Status.End;
                nextPlayer = Player.White;
            }
            else
            {
                //ʤ
                res.Status = this.CheckGameResult(step,player);
                switch (res.Status)
                {
                    case Status.Playing:
                        nextPlayer = player==Player.White?Player.Black:Player.White;
                        res.Player = nextPlayer;
                        break;
                    case Status.End:
                        res.Player = player;
                        nextPlayer = Player.White;
                        break;

                }
            }
            //¼
            OnStatusChanged(new GameEventArgs(res,History,checkerBoard));
            return true;
        }

        public void SetEventSinker(Player player,GameEventSinker sinker)
        {
            if (sinker != null)
            {
                this.sinkerlist[player] = sinker;
                GameEventHandler h =new GameEventHandler(sinker.RaiseEvent);
                this.sinkerHandlerlist[player] = h;
                this.GameStatusChanged += h;
            }
        }


        public Player Join()
        {
            if (players.Count > 2)
                return Player.None;
            if (players.Count == 0)
            {
                players.Add(Player.Black);
                return Player.Black;
            }
            if (players.Count == 1)
            {
                players.Add(Player.White);
                nextPlayer = Player.Black;
                return Player.White;
            }
            return Player.None;
        }

        #endregion
}
}