using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.Collections;

namespace Chess
{
    public partial class FiveChessGame : UserControl
    {
        public FiveChessGame()
        {
            InitializeComponent();
            History = new Stack();
            Player =White;//ĬΪ
            Reset();
        }
        private const int None = -1;//û
        private const int White = 0;//
        private const int Black = 1;//
        private int[,] checkerBoard = new int[15, 15];//(ÿһ)
        private int nextPlayer;//һѡ
        private int Player
        {
            get
            {
                return nextPlayer;
            }
            set
            {
                nextPlayer = value;
                ReDrawNextPlayerMark();
            }
        }
        private Stack History;//ʷ¼

        //ػ
        protected override void OnPaint(PaintEventArgs e)
        {
            System.Drawing.Graphics g = this.CreateGraphics();
            for (int x = 0; x < 15; x++)
            {
                for (int y = 0; y < 15; y++)
                {
                    if (checkerBoard[y, x] !=None) DrawChess(new Point(x, y), checkerBoard[y, x]);
                }
            }
            ReDrawNextPlayerMark();
            base.OnPaint(e);
        }



        //갴¼
        protected override void OnMouseDown(System.Windows.Forms.MouseEventArgs e)
        {
            base.OnMouseDown(e);
            switch (e.Button)
            {
                //take left button down
                case MouseButtons.Left:
                    if ((History.Count == 0) && (2 < e.X) && (e.X < 22) && (309 < e.Y) && (e.Y < 329))
                        Player = (Player ==White) ?Black :White;
                    else AddChess(MToA(new Point(e.X, e.Y)));
                    break;
                //take right button down
                case MouseButtons.Right:
                    // OnRButtonDown(new Point(e.X,e.Y));
                    break;
            }
        }



        //ת
        private Point MToA(Point p)
        {
            return new Point((p.X - 15) / 20, (p.Y - 6) / 20);
        }



        //ʼµ֣ݸλػ
        private void Reset()
        {
            for (int i = 0; i < 15; i++)
            {
                for (int j = 0; j < 15; j++)
                {
                    checkerBoard[i, j] =None;
                }
            }
            History.Clear();//ʷ¼
            DrawCheckerBoard();//ػ
        }



        //ػ
        private void DrawCheckerBoard()
        {
            this.BackColor = System.Drawing.SystemColors.Desktop;
            this.BackColor = System.Drawing.SystemColors.Control;
        }



        //ػһѡֵı־
        private void ReDrawNextPlayerMark()
        {
            System.Drawing.Graphics g = this.CreateGraphics();
            imageList1.Draw(g, 2, 309, 20, 20, Player);
        }



        //ϻһ
        private void DrawChess(Point pCoordinates, int iPlayer)
        {
            System.Drawing.Graphics g = this.CreateGraphics();
            imageList1.Draw(g, 15 + pCoordinates.X * 20, 6 + pCoordinates.Y * 20, 20, 20, iPlayer);
        }



        //ָλһ
        private void AddChess(Point p)
        {
            //жǷ񳬳߽
            if ((p.X < 0 || p.X > 14) || (p.Y < 0 || p.Y > 14)) return;
            //жϸλ
            if (checkerBoard[p.Y, p.X] !=None) return;//Ѿ˳岻£
            DrawChess(p, Player);
            if (Player ==White)//ð
            {
                checkerBoard[p.Y, p.X] =White;
                Player =Black;
            }
            else
            {
                checkerBoard[p.Y, p.X] =Black;
                Player =White;
            }
            History.Push(new Point(p.X, p.Y));//ʷ¼
            CheckGameResult(p);
        }



        //Ϸ
        /*
        * 㷨
        * ڸϷֻȷų 5 ӵһʣ
        * ֻҪԸո¹ǸΪģû 5 ͬɫӾͺˡ
        */
        private void CheckGameResult(Point sourcePoint)
        {
            int x, y;
            int LastPlayer = (Player ==White) ?Black :White;
            int n;



            //
            n = 1;
            y = sourcePoint.Y;
            for (x = sourcePoint.X - 1; x >= 0; x--)
            {
                if (checkerBoard[y, x] == LastPlayer) n++;
                else break;
            }
            for (x = sourcePoint.X + 1; x < 15; x++)
            {
                if (checkerBoard[y, x] == LastPlayer) n++;
                else break;
            }
            if (n >= 5)
            {
                Win(LastPlayer);
                return;
            }



            //
            n = 1;
            x = sourcePoint.X;
            for (y = sourcePoint.Y - 1; y >= 0; y--)
            {
                if (checkerBoard[y, x] == LastPlayer) n++;
                else break;
            }
            for (y = sourcePoint.Y + 1; y < 15; y++)
            {
                if (checkerBoard[y, x] == LastPlayer) n++;
                else break;
            }
            if (n >= 5)
            {
                Win(LastPlayer);
                return;
            }



            //б
            n = 1;
            for (x = sourcePoint.X + 1, y = sourcePoint.Y - 1; x < 15 && y >= 0; x++, y--)//бߵϰ
            {
                if (checkerBoard[y, x] == LastPlayer) n++;
                else break;
            }
            for (x = sourcePoint.X - 1, y = sourcePoint.Y + 1; x >= 0 && y < 15; x--, y++)//бߵ°
            {
                if (checkerBoard[y, x] == LastPlayer) n++;
                else break;
            }
            if (n >= 5)
            {
                Win(LastPlayer);
                return;
            }



            //б
            n = 1;
            for (x = sourcePoint.X - 1, y = sourcePoint.Y - 1; x >= 0 && y >= 0; x--, y--)//бߵϰ
            {
                if (checkerBoard[y, x] == LastPlayer) n++;
                else break;
            }
            for (x = sourcePoint.X + 1, y = sourcePoint.Y + 1; x < 15 && y < 15; x++, y++)//бߵ°
            {
                if (checkerBoard[y, x] == LastPlayer) n++;
                else break;
            }
            if (n >= 5)
            {
                Win(LastPlayer);
                return;
            }



            //壬ƽ
            if (History.Count >= 225)
            {
                Win(None);
                return;
            }



        }



        //ʾָѡֵĻʤϢ
        private void Win(int NPlayer)
        {
            switch (NPlayer)
            {
                case None:
                    MessageBox.Show("ƽ!", "ϲ");
                    break;
                case White:
                    MessageBox.Show("  ʤ !", "ϲ");
                    break;
                case Black:
                    MessageBox.Show("  ʤ !", "ϲ");
                    break;
            }
            Reset();
        }



        // 1 
        private void Penitence()
        {
            if (History.Count > 0)
            {
                Point p = (Point)History.Pop();
                checkerBoard[p.Y, p.X] =None;
                nextPlayer = (Player ==White) ?Black :White;
                DrawCheckerBoard();
            }
        }



        private void menuItem10_Click(object sender, System.EventArgs e)
        {
            Player = (Player ==White) ?Black :White;
        }



    }
}
