using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.Collections;

namespace FiveChess
{
    public partial class RemoteGame : UserControl
    {
        public static readonly string ObjUrl = "FiveChess";
        public static readonly string Port = "5555";
        /// <summary>
        /// IPַURI
        /// </summary>
        /// <param name="ip"></param>
        /// <returns></returns>
        public static string BuildRemotingUrl(string ip)
        {
            return string.Format("tcp://{0}:{1}/{2}", ip,Port, ObjUrl);
        }
        public RemoteGame()
        {
            InitializeComponent();
            thePlayer =Player.Black;//ĬΪ
            Reset();
        }
        private Player[,] checkerBoard ;//(ÿһ)
        private Stack<Point> History;//ʷ¼
        private Player currentPlayer;//һѡ
        //ǰѡ
        private Player theplayer; 
        public Player thePlayer
        {
            get
            {
                return theplayer;
            }
            set
            {
                theplayer = value;
                ReDrawNextPlayerMark();
            }
        }

        public IGame game;
        public bool Blocked =false;
        private GameEventSinker sinker = new GameEventSinker(); 

        //ػ
        protected override void OnPaint(PaintEventArgs e)
        {
            base.OnPaint(e);
            if (checkerBoard == null) return;
            try
            {
                System.Drawing.Graphics g = this.CreateGraphics();
                for (int x = 0; x < 15; x++)
                {
                    for (int y = 0; y < 15; y++)
                    {
                        DrawChess(new Point(x, y), checkerBoard[x, y]);
                    }
                }
                ReDrawNextPlayerMark();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
        
        //갴¼
        protected override void OnMouseDown(System.Windows.Forms.MouseEventArgs e)
        {
            base.OnMouseDown(e);
            if (this.Blocked) return;
            switch (e.Button)
            {
                //take left button down
                case MouseButtons.Left:
                    //if ((History.Count == 0) && (2 < e.X) && (e.X < 22) && (309 < e.Y) && (e.Y < 329))
                    //    thePlayer = (thePlayer ==Player.White) ?Player.Black :Player.White;
                    //else 
                    AddChess(MToA(new Point(e.X, e.Y)));
                    break;
            }
        }
        
        //ת
        private Point MToA(Point p)
        {
            return new Point((p.X - 15) / 20, (p.Y - 6) / 20);
        }
        
        //ʼµ֣ݸλػ
        public void Reset()
        {
            checkerBoard = new Player[15, 15];
            History = new Stack<Point>();
            for (int i = 0; i < 15; i++)
            {
                for (int j = 0; j < 15; j++)
                {
                    checkerBoard[i, j] =Player.None;
                }
            }
            History.Clear();//ʷ¼
            DrawCheckerBoard();//ػ
        }
        
        //ػ
        private void DrawCheckerBoard()
        {
            this.BackColor = System.Drawing.SystemColors.Desktop;
            //this.BackColor = System.Drawing.SystemColors.Control;
        }
        
        //ػһѡֵı־
        private void ReDrawNextPlayerMark()
        {
            System.Drawing.Graphics g = this.CreateGraphics();
            if((int)theplayer < imageList1.Images.Count)
                imageList1.Draw(g, 2, 309, 20, 20, (int)thePlayer);
        }
        
        //ϻһ
        private void DrawChess(Point pCoordinates, Player iPlayer)
        {
            System.Drawing.Graphics g = this.CreateGraphics();
            if ((int)theplayer < imageList1.Images.Count )
                imageList1.Draw(g, 15 + pCoordinates.X * 20, 6 + pCoordinates.Y * 20, 20, 20, (int)iPlayer);
        }
        
        //ָλһ
        private void AddChess(Point p)
        {
            //жǷ񳬳߽
            if ((p.X < 0 || p.X > 14) || (p.Y < 0 || p.Y > 14)) return;
            //жϸλ
            if (checkerBoard[p.X, p.Y] != Player.None) return;//Ѿ˳岻£

            bool ok = game.Play(p, thePlayer);
            if (ok)
            {
                this.Blocked = true;
                //DrawChess(p, currentPlayer);
            }
       }


        //ʾָѡֵĻʤϢ
        private void Win(Player NPlayer)
        {

            if (NPlayer==Player.None)
            {
                    MessageBox.Show("ƽ!", "ϲ");
            }
            else if(NPlayer==theplayer)
            {MessageBox.Show("  ʤ !", "ϲ");
            }
            else
            {
                    MessageBox.Show("   !", "ź");
            }
            //Reset();
        }
        
        //IGAME
        public void SetIGame(IGame g)
        {
            this.game = g;
            game.SetEventSinker(thePlayer, sinker);
            this.sinker.GameStatusChanged += new GameEventHandler(sinker_GameStatusChanged);
        }

        void sinker_GameStatusChanged(object sender, GameEventArgs e)
        {
            this.History = e.History;
            checkerBoard = e.CheckerBoard;
            currentPlayer = e.Result.Player;
            //ػ
            this.Invalidate();
            //жϷ״̬
            switch (e.Result.Status)
            {
                case Status.Playing:
                    //ڽУжǷֵԼ
                    this.Blocked = e.Result.Player != thePlayer;
                    break;
                case Status.End:
                    //ϷʾʤϢ
                    this.Win(e.Result.Player);
                    break;
            }
        }


    }
}
